#!/usr/bin/python
#
# KconfigSize tool---to describe the result with a web form.
# Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GPLv2, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Created by Lei Wang<wlei@sh.nec-as.nec.com.cn>
# 2006-08-17 Modified by Lei Wang<wlei@sh.nec-as.nec.com.cn>
#

import sys, os, string
import cgi, shelve, cgitb
cgitb.enable()

from kc_kconfigweb_common import *

# global variable about db
db_dir = ""

# global variable about category
result_dir = "";
category_file = "";

TOP_TITLE = "<p><font size=+2><b>Bottom-up approach : %s</b></font></p>";
RAW_TITLE = "<tr valign=top><td><font size=+1><b>Raw data</b></font> %s</td><td><font size=+1><b>Total impact(Raw data - Base kernel)</b></font> %s</td></tr>" %(UNIT, UNIT);
EFFECT_TITLE = "<tr valign=top><td><font size=+1><b>Isolated Impact</b></font> %s<br></td></tr>" % UNIT;
ALL_TITLE = "<tr valign=top><td>Raw<br><br></td><td>Raw - Base<br><br></td><td>Impact<br><br></td></tr>";

CMP_RAW_TITLE = "<tr valign=top><td><font size=+1><b>Delta of raw data (target - source) </b></font> %s</td><td><font size=+1><b>Delta of total impact (target - source)</b></font> %s<br>\
</td></tr>" % (UNIT, UNIT);
CMP_EFFECT_TITLE = "<tr valign=top><td><font size=+1><b>Delta of isolated impact (target - source)</b></font> %s</td></tr>" % UNIT;
CMP_ALL_TITLE = "<tr valign=top><td>Raw of target - source<br><br></td><td>Raw - Base of target - source<br><br>\
</td><td>Impact of target - source<br><br></td></tr>";

ver_title = "<tr align=center><td align=center>Index<br><input type=button value=sort onClick=mysort(0)></td>\
<td align=center>Arch<br><input type=button value=sort onClick=mysort(1)></td>\
<td align=center>Mach<br><input type=button value=sort onClick=mysort(2)></td>\
<td align=center>Kernel Version<br><input type=button value=sort onClick=mysort(3)></td>\
<td align=center>Gcc Version<br><input type=button value=sort onClick=mysort(4)></td>\
<td align=center>Target List file</td><td align=center>db file</td><td align=center>Category</td></tr>";

def run():
    
    index_script = '''var index = -1;
var isAscend = [1, 1, 1, 1, 1];	    
function cmp(a, b) {
	if (isAscend[index] == 1) {
		if(index == 1 || index == 2) {
			if (a[index] > b[index]) 
				return 1;
			if (a[index] < b[index])
				return -1;
			if (parseInt(a[0]) > parseInt(b[0]))
				return 1;
			else 
				return -1;
		} else {
			var versa = a[index].split(".");
			var versb = b[index].split(".");
			var i = 0;
			for(i=0; i<versa.length; i++) {
				if (i >= versb.length)
					return 1;
				if (parseInt(versa[i]) == parseInt(versb[i]))
					continue;
				if (parseInt(versa[i]) > parseInt(versb[i]))
					return 1;
				if (parseInt(versa[i]) < parseInt(versb[i]))
					return -1;
			}
			if(i < versb.length)
				return -1;
			if (parseInt(a[0]) > parseInt(b[0]))
				return 1;
			else 
				return -1;
		}
	} else {
		if(index == 1 || index == 2) {
			if (a[index] > b[index]) 
				return -1;
			if (a[index] < b[index]) 
				return 1;
			if (parseInt(a[0]) > parseInt(b[0]))
				return -1;
			else 
				return 1;
		} else {
			var versa = a[index].split(".");
			var versb = b[index].split(".");
			var i = 0;
			for(i=0; i<versa.length; i++) {
				if (i >= versb.length)
					return -1;
				if (parseInt(versa[i]) == parseInt(versb[i]))
					continue;
				if (parseInt(versa[i]) > parseInt(versb[i]))
					return -1;
				if (parseInt(versa[i]) < parseInt(versb[i]))
					return 1;
			}
			if(i < versb.length)
				return 1;
			if (parseInt(a[0]) > parseInt(b[0]))
				return -1;
			else 
				return 1;
		}			
	}
}
function mysort(ind) {
	index = ind;
	isAscend[index] = (isAscend[index] + 1) % 2;
	var d = new Array();
	for (i=1; i<mytable.rows.length; i++) {
		var s = [];
		var length_c = mytable.rows[i].cells.length;
		for(j=0; j<length_c; j++) {
			s[j] = mytable.rows[i].cells[j].innerHTML;
		}
		d.push(s);
	}
	d.sort(cmp);
	for(i=1; i<mytable.rows.length; i++) {
		for(j=0; j<mytable.rows[i].cells.length; j++)
			mytable.rows[i].cells[j].innerHTML = d[i-1][j];
	}
	return false;
}
function checkVers() {
	var objSelect = document.myform2.myvers;
	if (objSelect.selectedIndex == -1) {
		alert("you must choose at least one versions!");
		return false;
	} else {
		if (objSelect.options[0].selected)
			return true;
		else {
			for (i=1, j=0; i<objSelect.options.length; i++) {
				if (objSelect.options[i].selected)
					j++;
				if (j > 1)
					return true;
			}
			alert("Notice that you just choosed one verion to be compared!");
			return true;
		}
	}
	return false;
}
function check(name) {
	var objForm = document.getElementById(name);
	if (objForm.category.selectedIndex == -1) {
		alert("you must choose at least one category!");
		return false;
	} else {
		return true;
	}
}
function checkCmp() {
	var objSource = document.myform.mysource;
	var objTarget = document.myform.mytarget;
	var objCate = document.myform.mycate;
	if (objSource.selectedIndex == 0) {
		alert("you must choose one source!");
		return false;
	} 
	if (objTarget.selectedIndex == 0) {
		alert("you must choose one target!");
		return false;
	} 
	if (objCate.selectedIndex == -1) {
		alert("you must choose at least one category!");
		return false;
	}
	if (objSource.selectedIndex == objTarget.selectedIndex) {
		alert("notice! the source and target are the same one.");
		return true;
	}
	return true;
}
function getCommCate(key1, key2) {
	var cate = new Array();
	for (i=0; i<key1.category.options.length; i++) {
		for (j=0; j<key2.category.options.length; j++) {
			if (key1.category.options[i].text == key2.category.options[j].text) {
				cate[cate.length] = key1.category.options[i].text;
				break;
			}
		}
	}
	return cate;
}	
function setParam(objSelect) {
	var objSource = document.myform.mysource;
	var objTarget = document.myform.mytarget;
	var objCate = document.myform.mycate;
	if (objSelect == objSource) {
		var objArch1 = document.myform.arch1;
		var objMach1 = document.myform.mach1;
		var objVer1 = document.myform.ver1;
		var objGcc1 = document.myform.gcc1;
		var objBaseconf1 = document.myform.baseconf1;
		var objDbname1 = document.myform.dbname1;
		var i = 0;
		for(i=1; i<mytable.rows.length; i++) {
			if(mytable.rows[i].cells[0].innerHTML == String(objSelect.selectedIndex)) {
				objArch1.value = mytable.rows[i].cells[1].innerHTML;
				objMach1.value = mytable.rows[i].cells[2].innerHTML;
				objVer1.value = mytable.rows[i].cells[3].innerHTML;
				objGcc1.value = mytable.rows[i].cells[4].innerHTML;
				objBaseconf1.value = mytable.rows[i].cells[5].innerHTML;
				objDbname1.value = mytable.rows[i].cells[6].innerHTML;
			}
		}
		var key = document.getElementById("catform" + objSelect.selectedIndex);
		if (objCate.options.length <= 0) {
			for (i=0; i<key.category.options.length; i++) {
				var op = new Option(key.category.options[i].text);
				objCate.options[objCate.options.length] = op;
			}
		} else {
			var key2 = document.getElementById("catform" + objTarget.selectedIndex);
			var cate = getCommCate(key, key2);
			var length = objCate.options.length;
			for (i=length-1; i>=0; i--) {
				objCate.options[i] = null;
			}
			for (i=0; i<cate.length; i++) {
				var op = new Option(cate[i]);
				objCate.options[objCate.options.length] = op;
			}
		}
	} else {
		var objArch2 = document.myform.arch2;
		var objMach2 = document.myform.mach2;
		var objVer2 = document.myform.ver2;
		var objGcc2 = document.myform.gcc2;
		var objBaseconf2 = document.myform.baseconf2;
		var objDbname2 = document.myform.dbname2;
		var i = 0;
		for(i=1; i<mytable.rows.length; i++) {
			if(mytable.rows[i].cells[0].innerHTML == String(objSelect.selectedIndex)) {
				objArch2.value = mytable.rows[i].cells[1].innerHTML;
				objMach2.value = mytable.rows[i].cells[2].innerHTML;
				objVer2.value = mytable.rows[i].cells[3].innerHTML;
				objGcc2.value = mytable.rows[i].cells[4].innerHTML;
				objBaseconf2.value = mytable.rows[i].cells[5].innerHTML;
				objDbname2.value = mytable.rows[i].cells[6].innerHTML;
			}
		}
		var key = document.getElementById("catform" + objSelect.selectedIndex);
		if (objCate.options.length <= 0) {
			for (i=0; i<key.category.options.length; i++) {
				var op = new Option(key.category.options[i].text);
				objCate.options[objCate.options.length] = op;
			}
		} else {
			var key2 = document.getElementById("catform" + objSource.selectedIndex);
			var cate = getCommCate(key, key2);
			var length = objCate.options.length;
			for (i=length-1; i>=0; i--) {
				objCate.remove(i);
			}
			for (i=0; i<cate.length; i++) {
				var op = new Option(cate[i]);
				objCate.options[objCate.options.length] = op;
			}
		}
	}
}''';

    showdata_script = '''var index = -1;
var raw = -1;
var isAscend = [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
function cmp(a, b) {
	if (isAscend[index + 6 * raw] == 1) {
		if (a[index] == "failed")
			return -1;
		if (b[index] == "failed")
			return 1;
		if (a[index] == "undefined")
			return -1;
		if (b[index] == "undefined")
			return 1;
		if (index != 0) {
			if (parseInt(a[index]) > parseInt(b[index]))
				return 1;
			if (parseInt(a[index]) < parseInt(b[index]))
				return -1;
		}
		if (a[0] > b[0])
			return 1;
		return -1;
	} else {
		if (a[index] == "failed")
			return 1;
		if (b[index] == "failed")
			return -1;
		if (a[index] == "undefined")
			return 1;
		if (b[index] == "undefined")
			return -1;
		if (index != 0) {
			if (parseInt(a[index]) > parseInt(b[index]))
				return -1;
			if (parseInt(a[index]) < parseInt(b[index]))
				return 1;
			if (a[0] > b[0])
				return 1;
			return -1;
		} else {
			if (a[index] > b[index])
				return -1;
			return 1;
		}
	}	
}
function mysort(ind, isRaw) {
	index = ind;
	raw = isRaw;
	isAscend[index + 6 * raw] = (isAscend[index + 6 * raw] + 1) % 2;
	var d = new Array();
	if (isRaw == 1) {
		var length = mytable_r.rows.length;
		for(i=1; i<length; i++) {
			var s = [];
			var length_c = mytable_r.rows[i].cells.length;
			for (j=0; j<length_c; j++)
				s[j] = mytable_r.rows[i].cells[j].innerHTML;
			d.push(s);
		}
		d.sort(cmp);
		for(i=1; i<length; i++) {
			var length_c = mytable_r.rows[i].cells.length;
			for (j=0; j<length_c; j++)
				mytable_r.rows[i].cells[j].innerHTML = d[i-1][j];
		}
	} else if (isRaw == 2) {
		var src = document.images[0].src;
		var result = src.indexOf("sort_by");
		if (result != -1)
			src = src.substring(0, result);
		document.images[0].src = src + "sort_by=" + ind + "_" + isAscend[index + 6 * raw];
		var length = mytable_rb.rows.length;
		for(i=1; i<length; i++) {
			var s = [];
			var length_c = mytable_rb.rows[i].cells.length;
			for (j=0; j<length_c; j++)
				s[j] = mytable_rb.rows[i].cells[j].innerHTML;
			d.push(s);
		}
		d.sort(cmp);
		for(i=1; i<length; i++) {
			var length_c = mytable_rb.rows[i].cells.length;
			for (j=0; j<length_c; j++)
				mytable_rb.rows[i].cells[j].innerHTML = d[i-1][j];
		}
	} else {
		var src = document.images[document.images.length-1].src;
		var result = src.indexOf("sort_by");
		if (result != -1)
			src = src.substring(0, result);
		document.images[document.images.length-1].src = src + "sort_by=" + ind + "_" + isAscend[index + 6 * raw];
		var length = mytable_e.rows.length;
		for(i=1; i<length; i++) {
			var s = [];
			var length_c = mytable_e.rows[i].cells.length;
			for (j=0; j<length_c; j++)
				s[j] = mytable_e.rows[i].cells[j].innerHTML;
			d.push(s);
		}
		d.sort(cmp);
		for(i=1; i<length; i++) {
			var length_c = mytable_e.rows[i].cells.length;
			for (j=0; j<length_c; j++)
				mytable_e.rows[i].cells[j].innerHTML = d[i-1][j];
		}
	}		
}''';

    form = cgi.parse()

    # This is the root page of bottom up test of kconfig. It helps people to make some basic 
    # choise about what they wat to see.
    if not form.has_key("cmd") :
        header()
	
	files = os.listdir(db_dir);
	
	all = [];
	for file in files :
		if file.find("_bu.db") == -1 :
			continue;
		try :
			confdb = shelve.open(os.path.join(db_dir, file), flag="r");
		except :
			error("\"%s\" is a invalid file!" % file, top);
			return;	
		keys = confdb.keys();
		if keys == [] :
			error("\"%s\" is a invalid file!" % file, top);
			return;
		arch_item, mach_item, ver_item, gcc_item, \
			baseconf_item, conf_item, re_item = keys[0].split("-", 6);
		dbname_item = file;
		item = "-".join([arch_item, mach_item, ver_item, gcc_item, baseconf_item, dbname_item]);
		if item not in all :
			all.append(item);
		confdb.close();
	if all == [] :
		error("no data base!", top);
		return;
	all.sort(compare_ver);

	cate_dict = {};
        for key in all :
		arch_item, mach_item, ver_item, gcc_item, baseconf_item, dbname_item = key.split("-", 5);
		cate_path =  dbname_item[0:-2] + "cat";
		cate_path = os.path.join(result_dir, cate_path);
		cates = get_category(os.path.join(db_dir, dbname_item), cate_path);
		if len(cates) == 0 :
			error("something wrong with \"%s\" file!" % cate_path, top);
			return;
		cates.sort();
		cate_dict[key] = cates;
		

        printTitle("kconfigsize-bottom_up");

	# some javascript code for checking and preparing
	printScript(index_script);

        print "<p><a href='%s?'>top</a></p>" % top;
	print "<hr>";
	print TOP_TITLE % "Examination result";
	
	# the list of version type
	print "<font size=+1><b>Examinated conditions</b></font>";
        print "<table id=mytable border=1>";
	print ver_title;
	index = 1;
        for key in all :
		arch_item, mach_item, ver_item, gcc_item, baseconf_item, dbname_item = key.split("-", 5);
            	print "<tr align=center><td>%d</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s\
</td><td>%s</td>" % (index, arch_item, mach_item, ver_item, gcc_item, baseconf_item, dbname_item);
		print "<td><form id=catform%s>" % index;
		print "<input type=hidden name=cmd value=show_data>";
		print "<input type=hidden name=arch value=\"%s\">" % arch_item;
		print "<input type=hidden name=mach value=\"%s\">" % mach_item;
		print "<input type=hidden name=ver value=\"%s\">" % ver_item;
		print "<input type=hidden name=gcc value=\"%s\">" % gcc_item;
		print "<input type=hidden name=baseconf value=\"%s\">" % baseconf_item;
		print "<input type=hidden name=dbname value=\"%s\">" % dbname_item;
		print "<select name=category multiple=multiple size=4>";
		print "<option selected>All</option>";
		for cate in cate_dict[key] :
			print "<option>%s</option>" % cate;
		print "</select><br>";
		print "<input value=show type=submit onClick=\'return check(\"%s\")\'>" % ("catform" + str(index));
		print "</form></td></tr>";
		index = index + 1;
	print "</table>";

	# choices for comparing
	print "<br>";
	print "<hr>";
	print "<form name=myform>";
	print "<input type=hidden name=cmd value=compare>";
	print "<input type=hidden name=arch1 value=none>";
	print "<input type=hidden name=mach1 value=none>";
	print "<input type=hidden name=ver1 value=none>";
	print "<input type=hidden name=gcc1 value=none>";
	print "<input type=hidden name=baseconf1 value=none>";
	print "<input type=hidden name=dbname1 value=none>";
	print "<input type=hidden name=arch2 value=none>";
	print "<input type=hidden name=mach2 value=none>";
	print "<input type=hidden name=ver2 value=none>";
	print "<input type=hidden name=gcc2 value=none>";
	print "<input type=hidden name=baseconf2 value=none>";
	print "<input type=hidden name=dbname2 value=none>";

	print "<p><font size=+1><b>Comparison between two conditions</b></font></p>";
	print "source: <select name=mysource onChange=setParam(this)>";
	print "<option selected></option>";
	for i in range(1, index) :
		print "<option>%d</option>" % i;
	print "</select>";
	print "target: <select name=mytarget onChange=setParam(this)>";
	print "<option selected></option>";
	for i in range(1, index) :
		print "<option>%d</option>" % i;
	print "</select>";
	print "category: <select name=mycate multiple=multiple size=4>";
	print "</select>";
	print "<input type=submit value=compare onClick=\"return checkCmp()\"></p>";
	print "</form>";
	
	# compare a special config item with by many vers
	print "<hr>";
	print "<form name=myform2>";
	print "<input type=hidden name=cmd value=show_item>";
	print "<p><font size=+1><b>Data trend</b></font></p>";
	print "<select name=myvers multiple=multiple size=4>";
	print "<option selected>All</option>";
	for key in all :
		print "<option>%s</option>" % key;
	print "</select>";
	print "<select name=re>";
	print r'<option selected value="Raw">Total impact</option>';
	print r'<option value="Impact">Isolated impact</option>';
	print r'<option value="Base">Base</option>';
	print "</select>";
	print "<input type=submit value=show onClick=\"return checkVers()\"></p>";
	print "</form>";

        print END;

    # This a page for people to make more detail choise of what they want 
    # depended on the basic choise.
    elif form["cmd"][0] == "show_data" :
	header();
	arch = form["arch"][0];
	mach = form["mach"][0];
	ver = form["ver"][0];
	gcc = form["gcc"][0];
	baseconf = form["baseconf"][0];
	dbname = form["dbname"][0];
	if not form.has_key("category") :
		error("you must choose at least one catergory", "");
		return;
	else :
		cates = form["category"];
		if "All" in cates :
			cates = ["All"];
	if form.has_key("re") :
		re = form["re"][0];
	else :
		re = "All";
	if form.has_key("sm") :
		sm = form["sm"][0];
	else :
		sm = "All";
	
	printTitle('-'.join([arch, mach, ver]));
	printScript(showdata_script);

        print "<p><a href='?'>top</a></p>";
	print "<hr>";
	print TOP_TITLE % "Examination result";
	print "<table border=1>";
	print "<tr><td><center>Condition:</center><br>";
	print "Arch = %s<br>Mach = %s<br>Version = %s<br>db file = %s</td>" % (arch, mach, ver, dbname);
	print "<td><form>";
	print "<input type=hidden name=cmd value=show_data>";
	print "<input type=hidden name=arch value=\"%s\">" % arch;
	print "<input type=hidden name=mach value=\"%s\">" % mach;
	print "<input type=hidden name=ver value=\"%s\">" % ver;
	print "<input type=hidden name=gcc value=\"%s\">" % gcc;
	print "<input type=hidden name=baseconf value=\"%s\">" % baseconf;
	print "<input type=hidden name=dbname value=\"%s\">" % dbname;
	for cate in cates :
		print "<input type=hidden name=category value=\"%s\">" % cate;
	printReOptions(re);
	printSmOptions(sm);
	print "<input type=submit value=show>";
	print "</form></td></tr>";
	print "</table>";
	printCateTable(cates);

	# describe the configures by some determined conditions
	if form.has_key("re") :
		items_r = [];
		items_e = [];
		cond = "-".join([arch, mach, ver, gcc, baseconf]);
		items = getConfItem(result_dir, category_file, os.path.join(db_dir, dbname), cond, cates);
		if items == [-1] :
			print "<p>Something wrong occured with the category file</p>";
			print END;
			return;
		items_r = items[0];
		items_e = items[1];
		base_size = [];
		for key in items_e :
			if key[0] == "BASE" :
				base_size = key[1:];
				break;

		result = haveData(items_r, sm);
		if not result :
			print NODATA;
			print END;
			return;
		if result == 2 :
			sm = "Size";
		elif result == 3 :
			sm = "Mem";

		print "<hr>";
		if (re == "All" or re == "Raw") :
			if haveImage(items_r, sm) :
				print '''<img src='?cmd=drawchart_raw;arch=%s;mach=%s;ver=%s;gcc=%s;\
baseconf=%s;dbname=%s;re=%s;sm=%s;''' % (arch, mach, ver, gcc, baseconf, dbname, re, sm);
				for cate in cates :
					print "category=%s;" % cate;
				print "'></p>";
		
		if (re == "All" or re == "Impact") :
			if haveImage(items_e, sm) :
				print '''<p><img src='?cmd=drawchart_effect;arch=%s;mach=%s;ver=%s;gcc=%s;\
baseconf=%s;dbname=%s;re=%s;sm=%s;''' % (arch, mach, ver, gcc, baseconf, dbname, re, sm);
				for cate in cates :
					print "category=%s;" % cate;
				print "'></p>";
					
		print "<hr>"
		print "<p>";
		print "<font size=+1><b>Base kernel data</b></font> %s" % UNIT;
		temp1 = base_size[0:];
		temp1.insert(0, "Base");
		temp = [];
		temp.append(temp1);
		printBaseTable(temp, sm);
		print "</p>";

		if re == "Raw" :
			print "<p>";
			print "<table>";
			print RAW_TITLE;
			print "<tr valign=top><td>";
			printTable("mytable_r", items_r, "raw", sm);
			print "</td><td>";
			items_rb = getRawBase(items_r, base_size, sm);
			printTable("mytable_rb", items_rb, "raw_base", sm);
			print "</td></tr>";
			print "</table>";
			print "</p>";
		elif re == "Impact" :
			print "<p>";
			print "<table>";
			print EFFECT_TITLE;
			print "<tr valign=top><td>";
			printTable("mytable_e", items_e, "effect", sm);
			print "</td></tr>";
			print "</table>";
			print "</p>";
		else :
			print "<p>";
			print "<table>";
			print RAW_TITLE;
			print "<tr valign=top><td>";
			printTable("mytable_r", items_r, "raw", sm);
			print "</td><td>";
			items_rb = getRawBase(items_r, base_size, sm);
			printTable("mytable_rb", items_rb, "raw_base", sm);
			print "</td></tr>";
			print "</table>";
			print "</p>";

			print "<p>";			
			print "<table>";
			print EFFECT_TITLE;
			print "<tr valign=top><td>";
			printTable("mytable_e", items_e, "effect", sm);
			print "</td></tr>";
			print "</table>";
			print "</p>";
		print REFERENCE;
	
	print END;

    # describe the compared configures with tow version by some determined conditions
    elif form["cmd"][0] == "compare" :
    	header();
	arch1 = form["arch1"][0];
	mach1 = form["mach1"][0];
	ver1 = form["ver1"][0];
	gcc1 = form["gcc1"][0];
	baseconf1 = form["baseconf1"][0];
	dbname1 = form["dbname1"][0];
	arch2 = form["arch2"][0];
	mach2 = form["mach2"][0];
	ver2 = form["ver2"][0];
	gcc2 = form["gcc2"][0];
	baseconf2 = form["baseconf2"][0];
	dbname2 = form["dbname2"][0];
	if not form.has_key("mycate") :
		error("you must choose at least one catergory", "");
		return;
	else :
		cates = form["mycate"];
		if "All" in cates :
			cates = ["All"];
	if form.has_key("re") :
		re = form["re"][0];
	else :
		re = "All";
	if form.has_key("sm") :
		sm = form["sm"][0];
	else :
		sm = "All";
	
	t1 = '-'.join([arch1, mach1, ver1]);
	t2 = '-'.join([arch2, mach2, ver2]);
	printTitle(' '.join([t1, " vs ", t2]));
	printScript(showdata_script);

        print "<p><a href='?'>top</a></p>";
	print "<hr>";
	print TOP_TITLE % "Comparison between 2 conditions";
	print "<table border=1>";
	print "<tr><td><center>Source condition:</center><br>";
	print "Arch = %s<br>Mach = %s<br>Version = %s<br>db file = %s</td>" % (arch1, mach1, ver1, dbname1);
	print "<td><center>Target condition:</center><br>";
	print "Arch = %s<br>Mach = %s<br>Version = %s<br>db file = %s</td>" % (arch2, mach2, ver2, dbname2);
	print "<td><form>";
	print "<input type=hidden name=cmd value=compare>";
	print "<input type=hidden name=arch1 value=\"%s\">" % arch1;
	print "<input type=hidden name=mach1 value=\"%s\">" % mach1;
	print "<input type=hidden name=ver1 value=\"%s\">" % ver1;
	print "<input type=hidden name=gcc1 value=\"%s\">" % gcc1;
	print "<input type=hidden name=baseconf1 value=\"%s\">" % baseconf1;
	print "<input type=hidden name=dbname1 value=\"%s\">" % dbname1;
	print "<input type=hidden name=arch2 value=\"%s\">" % arch2;
	print "<input type=hidden name=mach2 value=\"%s\">" % mach2;
	print "<input type=hidden name=ver2 value=\"%s\">" % ver2;
	print "<input type=hidden name=gcc2 value=\"%s\">" % gcc2;
	print "<input type=hidden name=baseconf2 value=\"%s\">" % baseconf2;
	print "<input type=hidden name=dbname2 value=\"%s\">" % dbname2;
	for cate in cates :
		print "<input type=hidden name=mycate value=\"%s\">" % cate;
	printReOptions(re);
	printSmOptions(sm);
	print "<input type=submit value=show>";
	print "</form></td></tr>";
	print "</table>";
	printCateTable(cates);

	# describe the configures by some determined conditions
	if form.has_key("re") :
		items_r1 = [];
		items_e1 = [];
		items_r2 = [];
		items_e2 = [];
		cond1 = "-".join([arch1, mach1, ver1, gcc1, baseconf1]);
		cond2 = "-".join([arch2, mach2, ver2, gcc2, baseconf2]);
		items1 = getConfItem(result_dir, category_file, os.path.join(db_dir, dbname1), cond1, cates);
		if items1 == [-1] :
			print "<p>Something wrong occured with the category file</p>";
			print END;
			return;
		items2 = getConfItem(result_dir, category_file, os.path.join(db_dir, dbname2), cond2, cates);
		if items2 == [-1] :
			print "<p>Something wrong occured with the category file</p>";
			print END;
			return;
		items_r1 = items1[0];
		items_e1 = items1[1];
		items_r2 = items2[0];
		items_e2 = items2[1];

		hash_r2 = {};
		for key in items_r2 :
			hash_r2[key[0]] = key[1:];
		hash_e2 = {};
		for key in items_e2 :
			hash_e2[key[0]] = key[1:];

		base_size = [];
		base_size1 = [];
		base_size2 = [];
		for key in items_e1 :
			if key[0] == "BASE" :
				base_size1 = key[1:];
				base_size2 = hash_e2[key[0]];
				for i in range(0, 5) :
					if isDigit(base_size1[i]) and isDigit(base_size2[i]) :
						base_size.append(-1 * (int(base_size1[i]) - int(base_size2[i])));
					else :
						base_size.append('');
				break;

		result = haveData(items_r1, sm);
		if not result :
			print NODATA;
			print END;
			return;
		if result == 2 :
			sm = "Size";
		elif result == 3 :
			sm = "Mem";

		result = haveData(items_r2, sm);
		if not result :
			print NODATA;
			print END;
			return;
		if result == 2 :
			sm = "Size";
		elif result == 3 :
			sm = "Mem";

		print "<hr>";
		if re == "All" or re == "Raw" : 
			if haveCmpImage(items_r1, items_r2, sm) :
				print '''<p><img src='?cmd=drawcmpchart_raw;arch1=%s;mach1=%s;ver1=%s;gcc1=%s;\
baseconf1=%s;dbname1=%s;''' % (arch1, mach1, ver1, gcc1, baseconf1, dbname1);
				print '''arch2=%s;mach2=%s;ver2=%s;gcc2=%s;baseconf2=%s;dbname2=%s;\
re=%s;sm=%s;''' % (arch2, mach2, ver2, gcc2, baseconf2, dbname2, re, sm);
				for cate in cates :
					print "mycate=%s;" % cate;
				print "'></p>";

		if re == "All" or re == "Impact" : 
			if haveCmpImage(items_e1, items_e2, sm) :
				print '''<p><img src='?cmd=drawcmpchart_effect;arch1=%s;mach1=%s;ver1=%s;gcc1=%s;\
baseconf1=%s;dbname1=%s;''' % (arch1, mach1, ver1, gcc1, baseconf1, dbname1);
				print '''arch2=%s;mach2=%s;ver2=%s;gcc2=%s;baseconf2=%s;dbname2=%s;\
re=%s;sm=%s;''' % (arch2, mach2, ver2, gcc2, baseconf2, dbname2, re, sm);
				for cate in cates :
					print "mycate=%s;" % cate;
				print "'></p>";

		print "<hr>";
		print "<p>";
		print "<font size=+1><b>Base kernel data</b></font> %s" % UNIT;
		temp1 = base_size1[0:];
		temp1.insert(0, "source condition");
		temp2 = base_size2[0:];
		temp2.insert(0, "target condition");
		temp3 = base_size[0:];
		temp3.insert(0, "delta of base (target - source)");
		temp = [];
		temp.append(temp1);
		temp.append(temp2);
		temp.append(temp3);
		printBaseTable(temp, sm);
		print "</p>";

		print "<p>";
		print "<table>";
		if re == "Raw" :
			print "<p>";
			print "<table>";
			print CMP_RAW_TITLE;
			print "<tr valign=top><td>";
			printCmpTable("mytable_r", items_r1, items_r2, "raw", sm);
			print "</td><td>";
			items_rb1 = getRawBase(items_r1, base_size1, sm);
			items_rb2 = getRawBase(items_r2, base_size2, sm);
			printCmpTable("mytable_rb", items_rb1, items_rb2, "raw_base", sm);
			print "</td></tr>";
			print "</table>";
			print "</p>"
		elif re == "Impact" :
			print "<p>";
			print "<table>";
			print CMP_EFFECT_TITLE;
			print "<tr valign=top><td>";
			printCmpTable("mytable_e", items_e1, items_e2, "effect", sm);
			print "</td></tr>";
			print "</table>";
			print "</p>"
		else :
			print "<p>";
			print "<table>";
			print CMP_RAW_TITLE;
			print "<tr valign=top><td>";
			printCmpTable("mytable_r", items_r1, items_r2, "raw", sm);
			print "</td><td>";
			items_rb1 = getRawBase(items_r1, base_size1, sm);
			items_rb2 = getRawBase(items_r2, base_size2, sm);
			printCmpTable("mytable_rb", items_rb1, items_rb2, "raw_base", sm);
			print "</td></tr>";
			print "</table>";
			print "</p>"

			print "<p>";
			print "<table>";
			print CMP_EFFECT_TITLE;
			print "<tr valign=top><td>";
			printCmpTable("mytable_e", items_e1, items_e2, "effect", sm);
			print "</td></tr>";
			print "</table>";
		print "</p>";

		print REFERENCE;
			
	print END;

    # describe a page for a special config item of many versions
    elif form["cmd"][0] == "show_item" :
	header();
	vers = form["myvers"];
	re = form["re"][0];
	if re == "Raw" :
		type = "raw";
	else :
		type = "effect";
	if form.has_key("confitem") :
		confitem = form["confitem"][0];
	else :
		confitem = "";

	files = os.listdir(db_dir);
	all = {};
	for file in files :
		if file.find("_bu.db") == -1 :
			continue;
		try :
			confdb = shelve.open(os.path.join(db_dir, file), flag="r");
		except :
			error("\"%s\" is a invalid file!" % file, "");
			return;	
		keys = confdb.keys();
		for key in keys :
			arch_item, mach_item, ver_item, gcc_item, \
				baseconf_item, conf_item, re_item = key.split("-", 6);
			dbname_item = file;
			if re_item != type :
				continue;
			item = "-".join([arch_item, mach_item, ver_item, gcc_item, baseconf_item, dbname_item]);
			if not all.has_key(item) :
				all[item] = {};
			all[item][conf_item] = confdb[key];
			if CP_FAIL in all[item][conf_item] :
				for i in range(0, 5) :
					all[item][conf_item][i] = "failed";
				continue;
			if MEM_FAIL in all[item][conf_item] :
				for i in range(2, 5) :
					all[item][conf_item][i] = "undefined";
			for i in range(0, 5) :
				if all[item][conf_item][i] == '' :
					all[item][conf_item][i] = "-";
		confdb.close();

	if vers[0] == "All" :
		vers = [];
		vers = all.keys();
		
	items = all[vers[0]].keys();
	if len(vers) > 1 :
		for i in range(len(items)-1, -1, -1) :
			item = items[i];
			for j in range(1, len(vers)) :
				if not all[vers[j]].has_key(item) :
					del items[i];
					break;
	items.sort();				
	printTitle("show item");
        print "<p><a href='?'>top</a></p>";
	print "<hr>";
	if re == "Base" :
		print TOP_TITLE % "Data trend of base kernel";
	elif re == "Raw" :
		print TOP_TITLE % "Data trend of total impact";
	else :
		print TOP_TITLE % "Data trend of isolated impact";

	if re != "Base" :
		print "<p>please choose a config item you want to see the trend<br>"
		print "<form name=myform>";
		print "<input type=hidden name=cmd value=show_item>";
		for ver in vers :
			print "<input type=hidden name=myvers value=%s>" % ver;
		print "<input type=hidden name=re value=%s>" % re;
		print "<select name=confitem size=10>";
		for key in items :
			if key == "BASE" or key == "NONE" :
				continue;
			if key == confitem :
				print "<option selected>%s</option>" % key;
			else :
				print "<option>%s</option>" % key;
		print "</select>";
		print "<input type=submit value=show>";
		print "</form>";

	if form.has_key("confitem") or re == "Base" :
		if re == "Base" :
			confitem = "BASE";
		print "<br>";
		print "<hr>";
		print "<p><font size=+1><b>";
		if re == "Base" :
			print "Base kernel data trend";
		elif re == "Raw" :
			print "Total impact trend : %s" % confitem;
		else :
			print "Isolated impact trend : %s" % confitem;
		print "</b></font></p>";

		for i in range(0, 5) :
			has = 0;
			for j in range(0, len(vers)) :
				if isDigit(all[vers[j]][confitem][i]) :
					has = has + 1;
					if has >= 2 :
						break;
			if has <= 1 :
				continue;
			print "<p><img src='?cmd=drawline;re=%s;confitem=%s;type=%s;" % (re, confitem, sub_title[i]);
			for j in range(0, len(vers)) :
				if not isDigit(all[vers[j]][confitem][i]) :
					continue;
				if re == "Raw" :
					print "data=%d;" % (int(all[vers[j]][confitem][i]) - int(all[vers[j]]["NONE"][i]));
				else :
					print "data=%s;" % all[vers[j]][confitem][i];
				print "label=%d;" % (j+1);
			print "'></p>";

		print "<hr>";
		print "<p>";
		if re == "Base" :
			print "<font size=+1><b>Numerical data of Base kernels</b></font> %s" % UNIT;
		elif re == "Raw" :
			print "<font size=+1><b>Numerical data of Total impact : %s</b></font> %s" % (confitem, UNIT);
		else :
			print "<font size=+1><b>Numerical data of Isolated impact : %s</b></font> %s" % (confitem, UNIT);
		print "<table border=1>";
		if re == "Raw" :
			print raw_showitem;
		elif re == "Impact" :
			print effect_showitem;
		else :
			print base_showitem;
		for i in range(0, len(vers)) :
			print "<tr><td>%d</td><td>%s</td>" % (i+1, vers[i]);
			for j in range(0, 5) :
				if re == "Raw" :
					print "<td>%d</td>" % (int(all[vers[i]][confitem][j])-int(all[vers[i]]["NONE"][j]));
				else :
					print "<td>%s</td>" % all[vers[i]][confitem][j];
			print "</tr>";
		print "</table>";
		print "</p>";
		print REFERENCE;
	print END;
	
    # create an line picture for a special config item of many versions
    elif form["cmd"][0] == "drawline" :
	header("image/png");
	re = form["re"][0];
	confitem = form["confitem"][0];
	type = form["type"][0];
	data = form["data"];
	label = form["label"];
	#for i in range(1, len(data)+1) :
	#	label.append(i);

	x = gdchart.Line();
	x.width = LINE_WIDTH + 16 * len(data);
	x.height = LINE_HEIGHT + 8 * len(data);
#	x.title = "MAYBE NEED TO MODIFY\nthe line of %s %s for\n %s\n\n" % (re, type, confitem);
	if re == "Base" :
		x.title = "Base kernel\nTrend of %s\n\n" % type;
	elif re == "Impact" :
		x.title = "%s\nTrend of isolated impact for %s\n\n" % (confitem, type);
	else :
		x.title = "%s\nTrend of total impact for %s\n\n" % (confitem, type);
	x.set_color = ["red"];
	data = [int(e) for e in data];
	x.setData(data);
	x.setLabels(label);
	x.draw(sys.stdout);

    # create an effect chart picture of configures about one arch-ver 
    elif form["cmd"][0] == "drawchart_effect" :
    	header("image/png");
	arch = form["arch"][0];
	mach = form["mach"][0];
	ver = form["ver"][0];
	gcc = form["gcc"][0];
	baseconf = form["baseconf"][0];
	dbname = form["dbname"][0];
	cates = form["category"];
	re = form["re"][0];
	sm = form["sm"][0];
	if form.has_key("sort_by") :
		sort_by = form["sort_by"][0];
	else :
		sort_by = "";

	cond = "-".join([arch, mach, ver, gcc, baseconf]);
	data = getConfData(result_dir, category_file, os.path.join(db_dir, dbname), cond, cates, sm, "effect", sort_by);
	title = "Isolated impact of config items\n %s-%s-%s\n\n" % (arch, mach, ver);
	drawChart(data, title, sm, "effect");

    # create an effect chart picture of configures about one arch-ver 
    elif form["cmd"][0] == "drawchart_raw" :
    	header("image/png");
	arch = form["arch"][0];
	mach = form["mach"][0];
	ver = form["ver"][0];
	gcc = form["gcc"][0];
	baseconf = form["baseconf"][0];
	dbname = form["dbname"][0];
	cates = form["category"];
	re = form["re"][0];
	sm = form["sm"][0];
	if form.has_key("sort_by") :
		sort_by = form["sort_by"][0];
	else :
		sort_by = "";

	cond = "-".join([arch, mach, ver, gcc, baseconf]);
	data = getConfData(result_dir, category_file, os.path.join(db_dir, dbname), cond, cates, sm, "raw", sort_by);
	title = "Total impact of config items\n %s-%s-%s\n\n" % (arch, mach, ver);
	drawChart(data, title, sm, "raw");

    # create an effect compareing chart picture of configures about two arch-vers 
    elif form["cmd"][0] == "drawcmpchart_effect" :
    	header("image/png");
	arch1 = form["arch1"][0];
	mach1 = form["mach1"][0];
	ver1 = form["ver1"][0];
	gcc1 = form["gcc1"][0];
	baseconf1 = form["baseconf1"][0];
	dbname1 = form["dbname1"][0];
	arch2 = form["arch2"][0];
	mach2 = form["mach2"][0];
	ver2 = form["ver2"][0];
	gcc2 = form["gcc2"][0];
	baseconf2 = form["baseconf2"][0];
	dbname2 = form["dbname2"][0];
	cates = form["mycate"];
	re = form["re"][0];
	sm = form["sm"][0];
	if form.has_key("sort_by") :
		sort_by = form["sort_by"][0];
	else :
		sort_by = "";

	cond1 = "-".join([arch1, mach1, ver1, gcc1, baseconf1]);
	cond2 = "-".join([arch2, mach2, ver2, gcc2, baseconf2]);
	data = getCmpConfData(result_dir, category_file, os.path.join(db_dir, dbname1), os.path.join(db_dir, dbname2), cond1, cond2, cates, sm, "effect", sort_by);
	title = "Delta of isolated impact\n%s-%s-%s --> %s-%s-%s\n\n" % (arch1, mach1,\
	ver1, arch2, mach2, ver2);
	drawChart(data, title, sm, "effect");

    # create an raw compareing chart picture of configures about two arch-vers 
    elif form["cmd"][0] == "drawcmpchart_raw" :
    	header("image/png");
	arch1 = form["arch1"][0];
	mach1 = form["mach1"][0];
	ver1 = form["ver1"][0];
	gcc1 = form["gcc1"][0];
	baseconf1 = form["baseconf1"][0];
	dbname1 = form["dbname1"][0];
	arch2 = form["arch2"][0];
	mach2 = form["mach2"][0];
	ver2 = form["ver2"][0];
	gcc2 = form["gcc2"][0];
	baseconf2 = form["baseconf2"][0];
	dbname2 = form["dbname2"][0];
	cates = form["mycate"];
	re = form["re"][0];
	sm = form["sm"][0];
	if form.has_key("sort_by") :
		sort_by = form["sort_by"][0];
	else :
		sort_by = "";

	cond1 = "-".join([arch1, mach1, ver1, gcc1, baseconf1]);
	cond2 = "-".join([arch2, mach2, ver2, gcc2, baseconf2]);
	data = getCmpConfData(result_dir, category_file, os.path.join(db_dir, dbname1), os.path.join(db_dir, dbname2), cond1, cond2, cates, sm, "raw", sort_by);
	title = "Delta of total impact\n %s-%s-%s --> %s-%s-%s\n\n" % (arch1, mach1,\
	ver1, arch2, mach2, ver2);
	drawChart(data, title, sm, "raw");

    # If comes here, it means something wrong with this web page
    else:
        header()
        print "dunno"
        print form["cmd"]
