#! /bin/sh

# Memory measuremtn using qemu
# $1 : kernel image path
# $2 : kernel parameter
# $3 : disk image path

if [ $# != 3 ] ; then
  echo "usage : `basename $0` <kernel_image> <kernel_param> <disk_image>"
  exit 1
fi

qemu -nographic -kernel $1 -append "$2" $3 &

exit 0

