#!/bin/bash

#
# KconfigSize tool---using parallel port to reset target board 
# Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GPLv2, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Created by Lv Zheng <zhengl@sh.necas.nec.com.cn>
# 2006-02-20 Modified by Mingwei Wang <wangmw@sh.necas.nec.com.cn>
#

target_reset()
{
    if [ ! -c /dev/parport0 ]; then
        echo "target_reset: parallele port invalid"
        exit 3
    fi
    $TRESET 0x00
    sleep 2
    $TRESET 0xff
}

TRESET=$1

target_reset

