#!/usr/bin/python
#
# KconfigSize tool---to describe the result with a web form.
# Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GPLv2, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Created by Lei Wang<wlei@sh.nec-as.nec.com.cn>
# 2006-08-17 Modified by Lei Wang<wlei@sh.nec-as.nec.com.cn>
#

import os,sys
import kc_kconfigweb_bu

CONF_FILE = "../../conf/kconfigweb.conf";

def main () :
	kc_kconfigweb_bu.top = "kconfigweb.cgi";
	try :
		link = os.readlink(sys.argv[0]);
		items = os.path.split(link);
		os.chdir(items[0]);
	except :
		pass;
	try :
		f = open(CONF_FILE, 'r');
	except :
		kc_kconfigweb_bu.header();
		kc_kconfigweb_bu.error("Something wrong occured with %s config file!" % CONF_FILE, kc_kconfigweb_bu.top);
		return;
		
	lines = f.readlines();
	f.close();
	for line in lines :
		if line[0] == "#" :
			continue;
		items = line.split("=", 1);
		if len(items) < 2 :
			continue;
		if items[0].strip() == "db_dir" :
			kc_kconfigweb_bu.db_dir = items[1].strip();
			kc_kconfigweb_bu.result_dir = items[1].strip();
			
	if len(kc_kconfigweb_bu.top) == 0 :
		kc_kconfigweb_bu.header();
		kc_kconfigweb_bu.error("%s file is not set correctly!" % CONF_FILE, "null");
		return;

	if len(kc_kconfigweb_bu.db_dir) == 0 :
		kc_kconfigweb_bu.header();
		kc_kconfigweb_bu.error("%s file is not set correctly!" % CONF_FILE, kc_kconfigweb_bu.top);
		return;
		
	if not os.path.isdir(kc_kconfigweb_bu.db_dir) :
		kc_kconfigweb_bu.header();
		kc_kconfigweb_bu.error("\"%s\" dir not exist!" % kc_kconfigweb_bu.db_dir, kc_kconfigweb_bu.top);
		return;
	
	kc_kconfigweb_bu.run();

if __name__ == "__main__" :
	main();

