#!/bin/sh
#
# KconfigSize tool---get meminfo by dmesg with patched kernel
# Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GPLv2, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Created by Guohuang Yin<yingh@sh.necas.nec.com.cn>
# 2006-05-10 Modified by Guohuang Yin <yingh@sh.necas.nec.com.cn>
#
# Usage:meminfo.sh

#set -e

#get total and free
meminfo=`dmesg | grep -e "\<total: " | grep -e "\<free: " `
total=`echo $meminfo | sed -e 's/.*total: //' -e 's/free: [[:digit:]]*//' `
free=`echo $meminfo | sed -e 's/.*total: [[:digit:]]* free: //' `

#output to stdout 
if [ $total ]; then
	free=`expr $free \* 4096`
	total=`expr $total \* 4096`
	used=`expr $total - $free`
	echo "RST $total,$used,$free"
fi
echo "Going_to_shutdown"
halt

exit 0

