/*
 * KconfigSize tool
 * Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GPLv2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Created by Lv Zheng <zhengl@sh.necas.nec.com.cn>
 * 2006-02-20 Modified by  Fan Wu<wuf@sh.necas.nec.com.cn>
 */

#ifndef __WIN32_PORTABLE_H
#define __WIN32_PORTABLE_H

#ifdef WIN32
#define inline

#define vsnprintf       _vsnprintf
#define S_ISDIR(x)  _S_IFDIR&&x
#define S_ISREG(x)  _S_IFREG&&x
#endif

#ifndef WIN32
#define DIRDELIM	"/"
#define DIRDELIMC	'/'
#else
#define DIRDELIM	"\\"
#define DIRDELIMC	'\\'
#endif

#endif /* __WIN32_PORTABLE_H */
