/*
 * KconfigSize tool---Header file for using serial core
 * Copyright (C) 2005-2006 NEC-AS/NEC. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GPLv2, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Written by IKEDA, Munehiro <m-ikeda@ds.jp.nec.com>
 */

#ifndef _SERIAL_CORE_H
#define _SERIAL_CORE_H

#include <termio.h>

/* global function prototypes */
void set_params(int fd, char *baudr, char *par, char *bits,
		char *stopb, int hwf, int swf);
int setup_serial(const char *conf);

#endif	/* _SERIAL_CORE_H */
